from flask import Flask
from baseRoutes import baseRoutes
from storeRoutes import storeRoutes
from dashRoutes import dashRoutes
from dbCreater import db
import context_processors

"""
Samotna aplikace webu, ktera funguje jako spoustec

Vola si jednotlive Blueprinty, kde jsou ulozeny moduly s jednotlivymi weby a databaze

vola si i databaze z duvodu dalsi prace s nimi v aplikaci
"""

app = Flask(__name__)
app.register_blueprint(baseRoutes, url_prefix="")
app.register_blueprint(storeRoutes, url_prefix="/store")
app.register_blueprint(dashRoutes, url_prefix="/dashboard")

app.config['SQLALCHEMY_DATABASE_URI'] = 'sqlite:///furniture.db'
app.config['SQLALCHEMY_BINDS'] = { 'cart': 'sqlite:///cart.db', 'message': 'sqlite:///chatbot.db' }

#context processor, ktery slouzi jako globalni promenna pro cely projekt, z duvodu nutnosti prace v javascriptu
app.context_processor(context_processors.messages)

db.init_app(app)

app.secret_key = 'tohle je muj secret key'

if __name__ == "__main__":
	app.run(debug=True)