from flask import redirect, redirect, flash
from models import Furniture, Cart, Chatbot_message, User_message
from dbCreater import db
from sqlalchemy import desc

"""
Definice vsech funkci (modulu), ktere pouzivame se samotnym obchodem
"""


#funkce pomoci ktereho definujeme novou tridu pro nabytek
def newFurniture (furn_name, furn_type, furn_color, furn_price, furn_desc,
                 furn_sale, furn_stored):
    new_furniture = Furniture(name = furn_name, type_furniture = furn_type, 
                                      color = furn_color, price = furn_price, desc = furn_desc,
                                      sale = furn_sale, stored = furn_stored )
    return new_furniture

#funkce pro zapsani nebo aktualizaci nabytku do databaze
def checkingTypeFurniture (newFurniture, what_action):
    kind_furniture_allowed = ['zidle', 'stul', 'kreslo', 'skrin', 'postel']
    for check in kind_furniture_allowed:
        if newFurniture.type_furniture == check:
            try:
                if what_action == "create":
                    db.session.add(newFurniture)

                db.session.commit()
                return redirect('/dashboard')
            except:
                return "There was an error with adding furniture"

    #pokud type nesouhlasi s povolenymi typy, funkce nevrati nic a na stranku vyhodi message
    flash("Dovolene typy nabytku: zidle, stul, kreslo, skrin, postel")
    return None

#serazeni vsech nabytku z databaze dle pozadavku uzivatele
def sortedFurn (sort_by):
    if sort_by == 'maxprice':
        furniture = Furniture.query.order_by(desc(Furniture.price*(100-Furniture.sale)))
    elif sort_by == 'minprice':
        furniture = Furniture.query.order_by(Furniture.price*(100-Furniture.sale))
    elif sort_by == 'laststore':
        furniture = Furniture.query.order_by(Furniture.stored)
    elif sort_by == 'color':
        furniture = Furniture.query.order_by(Furniture.color)
    else: 
        furniture = Furniture.query.order_by(desc(Furniture.sale)).order_by(desc(Furniture.price))
    return furniture

#vytvoreni prvni casti linku na obrazky dle typu nabytku
def creatingPicLink1st (item):
    if (item.type_furniture == "zidle"):
        pic = "pictures/store/zidle/zidle_"
    elif (item.type_furniture == "kreslo"):
        pic = "pictures/store/kreslo/kreslo_"
    elif (item.type_furniture == "postel"):
        pic = "pictures/store/postel/postel_"
    elif (item.type_furniture == "stul"):
        pic = "pictures/store/stul/stul_"
    elif (item.type_furniture == "skrin"):
        pic = "pictures/store/skrin/skrin_"
    else:
        pic = "pictures/not_available.png"

    return pic

#vytvoreni druhe casti linku na obrazky dle barvy nabytku
def creatingPicLink2nd (item, link_1):
    if link_1 == "pictures/not_available.png":
        return link_1
    elif ((item.color == 'bila') or (item.color == "cerna") or (item.color == "seda") or
    (item.color == "modra") or (item.color == "oranzova") or (item.color == "hneda")):
        pic = link_1 + item.color + ".png"
    else:
        pic = "pictures/not_available.png"

    return pic

#vytvoreni pole, ktere bude obsahovat pro vsechen nabytek z databaze linky na obrazky dle typu a barvy
def whatPicShow (furnitures):
    array_pictures = [""] * furnitures.count()
    for idx, furniture in enumerate(furnitures):
        array_pictures[idx] = creatingPicLink1st(furniture)
        array_pictures[idx] = creatingPicLink2nd(furniture, array_pictures[idx])

    return array_pictures

#pridani produktu do databaze kosiku, vsechny potrebne informace ziskavame z databaze nabytku
def addProduct (idx):
    furnitures = sortedFurn(None)
    cartProduct = None
    for furniture in furnitures:
        if furniture.id == idx:
            cartProduct = Cart(id_product = furniture.id, name = furniture.name, 
                                      price = furniture.price, sale = furniture.sale)
    return cartProduct

#pridani nove zpravy chatbota do databaze
def botMessage (message_name, message_text, message_link):
    new_message = Chatbot_message(name = message_name, message = message_text, reference = message_link)
    return new_message

#pridani nove zpravy uzivatele do databaze a kontrola ID
def userMessage (message_text, next_id, prev_id):
    checked = checkID (next_id, prev_id)
    if checked == True:
        new_message = User_message(message = message_text, answer_id = next_id, 
                        chatbot_message_id = prev_id)
        return new_message
    else:
        return None
    
#kontrola zda odpovida ID predesle a nasledujici zpravy nejakemu id v chatbot zpravach
def checkID (next_mess_id, prev_mess_id):
    chatbot_messages = Chatbot_message.query
    for message in chatbot_messages:
        if int(next_mess_id) == message.id:
            for x in chatbot_messages:
                if int(prev_mess_id) == x.id:
                    return True
            
    flash("ID jedne ze zprav nesouhlasi s zadnym ID u chatbot zprav, zprava nemuze byt zapsana do databaze")
    return False




