from dbCreater import db
from datetime import datetime

"""
Definice vsech modelu/trid nasledne pouzitych v hlavnim programu aplikace
"""

#trida pouzita pro prihlasovani uzivatele
class User:
    def __init__(self, id, username, password):
        self.id = id
        self.username = username
        self.password = password

    def __repr__(self):
        return f'<User: {self.username}>'

#trida pouzita pro databazi, kam ukladame informace o nabytku a zpetnou praci s ni pri nacitani html stranek
class Furniture(db.Model):
    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(100), nullable=False)
    type_furniture = db.Column(db.String(10), nullable=False)
    color = db.Column(db.String(50), nullable=False)
    price = db.Column(db.Integer, nullable=False)
    desc = db.Column(db.String(10000), nullable=False)
    sale = db.Column(db.Integer, nullable=True)
    stored = db.Column(db.Integer, nullable=True)
    date_created = db.Column(db.DateTime, default=datetime.utcnow)

    def __repr__(self):
        return '<Name %r>' % self.id

#trida pouzita pro databazi, kam ukladame informace o produktech v kosiku a praci s ni
class Cart(db.Model):
    __bind_key__ = 'cart'
    __tablename__ = 'cart'
    id = db.Column(db.Integer, primary_key=True)
    id_product = db.Column(db.Integer, nullable=False)
    name = db.Column(db.String(100), nullable=False)
    price = db.Column(db.Integer, nullable=False)
    sale = db.Column(db.Integer, nullable=True)
    date_created = db.Column(db.DateTime, default=datetime.utcnow)

    def __repr__(self):
        return '<Name %r>' % self.id

#trida pouzita pro databazi, kam ukladame jednotlive zpravy chatbota k uzivateli
class Chatbot_message(db.Model):
    __bind_key__ = 'message'
    __tablename__ = 'chatbot_message'
    id = db.Column(db.Integer, primary_key=True)
    name = db.Column(db.String(100), nullable=False)
    message = db.Column(db.String(1000), nullable=False)
    reference = db.Column(db.String(100), nullable=True)
    user_messages = db.relationship('User_message', backref='question')

    def __repr__(self):
        return '<Name %r>' % self.id

    #funkce modelu pro vytvareni dictionary
    def to_dict(self):
        return {
            'id': self.id,
            'message': self.message,
            'name': self.name,
            'reference': self.reference
        }

#trida pouzita pro databazi, kam ukladame jednotlive zpravy uzivatele
class User_message(db.Model):
    __bind_key__ = 'message'
    __tablename__ = 'user_message'
    id = db.Column(db.Integer, primary_key=True)
    message = db.Column(db.String(1000), nullable=False)
    answer_id = db.Column(db.Integer, nullable=False)
    chatbot_message_id = db.Column(db.Integer, db.ForeignKey('chatbot_message.id'))

    def __repr__(self):
        return '<Name %r>' % self.id

    #funkce modelu pro vytvareni dictionary
    def to_dict(self):
        return {
            'id': self.id,
            'message': self.message,
            'answer_id': self.answer_id,
            'chatbot_message_id': self.chatbot_message_id
        }