﻿// prace s chatem, ktery probiha mezi uzivatelem a chatbotem

// vytvoreni si promenne se kterou budeme vyuzivat lokalni pamet pro uchovavani historie chatu
let historyArray = JSON.parse(localStorage.getItem("historyArray")) || [];
window.historyArray = historyArray;

// vytvoreni si promenne pro praci s hodnotou ceny uzite v doporucovani nabytku
let price = 0;

// pomoci teto funkce si volame "/chatbot", kde si uschovavame databazi ulozenou v json a zde ji extrahujeme
$(document).ready(function () {
    fetch('/chatbot')
        .then(response => response.json())
        .then(data => {
            // pokud uzivatel klikne na jedno z tlacitek probiha tento kod
            $('.chatbot_message').on('click', '.user_choice', function () {

                var buttonText = $(this).text();

                // snazime se najit lokalni pamet prohlizece, pokud ji uzivatel nema nebo ji ma malo, upozornime ho
                if (typeof (Storage) !== "undefined") {
                    if (localStorage.remainingSpace < 1000000) {
                        alert("Máte méně než 1 MB lokální paměti, měl byste ji promazat.");
                    }

                    // pushujeme vzdy novou odpoved uzivatele do nasi historie, pokud techto odpovedi mame ulozenych vice nez dvacet, tak jeho nejstarsi odpoved smazeme
                    if (historyArray.length >= 20) {
                        historyArray.shift();
                    }
                    historyArray.push(buttonText);
                    localStorage.setItem("historyArray", JSON.stringify(historyArray));

                }
                else {
                    alert("Bohužel nemůžeme pracovat s lokální pamětí, protože ji váš prohlížeč nepodporuje, to znamená že některé funkce chatbota nemusí fungovat správně.");
                }

                // zmacknute tlacitko uzivatele prepise jeho text i do chatu
                var newMessage = $('<p class="user">' + buttonText + '</p>');
                $(newMessage).appendTo('.chatbot_message');

                // smazeme vsechny ostatni tlacitka, krome exit tlacitka
                $('.user_choice:not(#exit)').remove();

                // ziskavame vzdy i id zpravy chatbota, ktera bude nasledovat
                var answerId = $(this).data("answer-id");

                // pokud uzivatel pracuje s vyberem nabytku dle ceny, uchovavame si jeho odpoved
                if (answerId == 47){
                    price = $("#range_price").val();
                }

                // hledani dle ID odpoved chatbota na uzivatelu zpravu
                var chatbotMessage = data.chatbot_messages.find(message => message.id == answerId);

                // smazani inputu, ktery muze byt soucasti odpovedi uzivatele
                $('.input_content').remove();

                // switch, ktery resi nektere specialni odpovedi chatbota s pridanim linku a inputu, defaulte vytvari zpravu chatbota
                switch (true) {
                    // moznost pridat si vlastni link je-li u dane odpovedi chatbota pridana hodnota reference
                    case chatbotMessage.reference != "":
                        var newChatbotMessage = '<p class="bot"><a target="_blank" href="' + chatbotMessage.reference + '" class="bot_link">' + chatbotMessage.message + '</a></p>';
                        break;

                    // pridani posuvniku ceny pri doporucovani nabytku dle ceny
                    case answerId == 9:
                        var newChatbotMessage = '<p class="bot">' + chatbotMessage.message + '</p>';
                        setTimeout(function () {
                            $('<div class="input_content" ><input type="range" id="range_price" name="price" value="100000" min="1" max="100000" oninput="changeInputValue(this.value)" /></div>').appendTo('.chatbot_message');
                            $('<div class="input_content" ><input type="number" id="price_input" min="1" value="100000" max="100000" onkeyup="changeRangeValue(this.value)" /><label for="price">Kc</label></div>').appendTo('.chatbot_message');
                        }, 3000);
                        break;

                    // pridani inputu emailu o navrhu mistnosti
                    case answerId == 13:
                        var newChatbotMessage = '<p class="bot">' + chatbotMessage.message + '</p>';
                        setTimeout(function () {
                            $('<div class="input_content" ><input type="email" id="chat_bot_email" name="email"/></div>').appendTo('.chatbot_message');

                        }, 3000);
                        break;

                    // vytvareni specialniho linku na nabytek pri doporucovani nabytku
                    case answerId == 46:
                        if (typeof (Storage) !== "undefined") {
                            const furnitures = ["Skříně", "Křesla", "Židle", "Stoly", "Postele"];
                            let furnitureRoad = "";

                            // hledani posledni odpovedi na druh nabytku
                            for (let i = historyArray.length - 1; i >= 0; i--) {
                                if (furnitures.includes(historyArray[i])) {
                                    switch (true) {
                                        case historyArray[i] == "Skříně":
                                            furnitureRoad = "/skrin";
                                            break;
                                        case historyArray[i] == "Křesla":
                                            furnitureRoad = "/kreslo";
                                            break;
                                        case historyArray[i] == "Židle":
                                            furnitureRoad = "/zidle";
                                            break;
                                        case historyArray[i] == "Stoly":
                                            furnitureRoad = "/stul";
                                            break;
                                        case historyArray[i] == "Postele":
                                            furnitureRoad = "/postel";
                                            break;
                                        default:
                                            furnitureRoad = "";
                                    }

                                    // doporucovani nabytku dle barvy
                                    switch (true) {
                                        case historyArray[historyArray.length - 2] == "Bílá":
                                            furnitureRoad += "/None/bila/0";
                                            break;
                                        case historyArray[historyArray.length - 2] == "Černá":
                                            furnitureRoad += "/None/cerna/0";
                                            break;
                                        case historyArray[historyArray.length - 2] == "Modrá":
                                            furnitureRoad += "/None/modra/0";
                                            break;
                                        case historyArray[historyArray.length - 2] == "Hnědá":
                                            furnitureRoad += "/None/hneda/0";
                                            break;
                                        case historyArray[historyArray.length - 2] == "Oranžová":
                                            furnitureRoad += "/None/oranzova/0";
                                            break;
                                        case historyArray[historyArray.length - 2] == "Šedá":
                                            furnitureRoad += "/None/seda/0";
                                            break;

                                        // doporucovani nabytku dle ceny
                                        case historyArray[historyArray.length - 2] == "Potvrdit maximální cenu.":
                                            furnitureRoad += "/None/all/" + price;
                                            break;

                                        // doporucovani nabytku dle mista urceni
                                        case (historyArray[historyArray.length - 2] == "Křeslo do obývacího pokoje."):
                                            furnitureRoad = "/search/houpák";
                                            break;
                                        case (historyArray[historyArray.length - 2] == "Křeslo do kanceláře."):
                                            furnitureRoad = "/search/hezu";
                                            break;
                                        case (historyArray[historyArray.length - 2] == "Židle na zahradu."):
                                            furnitureRoad = "/search/hezu";
                                            break;
                                        case (historyArray[historyArray.length - 2] == "Židle na zahradu."):
                                            furnitureRoad = "/search/shy";
                                            break;
                                        case (historyArray[historyArray.length - 2] == "Židle do jídelny."):
                                            furnitureRoad = "/search/obědovka";
                                            break;
                                        case (historyArray[historyArray.length - 2] == "Pracovní stoly."):
                                            furnitureRoad = "/search/pokoják";
                                            break;
                                        case (historyArray[historyArray.length - 2] == "Stoly do jídelny."):
                                            furnitureRoad = "/search/jidelák";
                                            break;
                                        case (historyArray[historyArray.length - 2] == "Postelové gauče."):
                                            furnitureRoad = "/search/usínačka";
                                            break;
                                        case (historyArray[historyArray.length - 2] == "Manželské postele."):
                                            furnitureRoad = "/search/forever";
                                            break;
                                        case (historyArray[historyArray.length - 2] == "Postele do pokoje."):
                                            furnitureRoad = "/search/mine";
                                            break;
                                        default:
                                    }

                                    break;
                                }
                            }

                            var newChatbotMessage = '<p class="bot"><a target="_blank" href="/store' + furnitureRoad + '" class="bot_link">' + chatbotMessage.message + '</a></p>';

                        }
                        else {
                            alert("Kvůli absenci lokální paměti nebo jine neocekavane chyby tato funkce nefunguje, odkážeme vás pouze do obchodu.");
                            var newChatbotMessage = '<p class="bot"><a target="_blank" href="/store" class="bot_link">' + chatbotMessage.message + '</a></p>';
                        }
                        break;

                    default:
                        var newChatbotMessage = '<p class="bot">' + chatbotMessage.message + '</p>';
                }

                // schovani exit tlacitka na urcitou dobu, aby se objevil az na konci ostatnich tlacitek
                $("#exit").hide();
                setTimeout(function () {
                    $("#exit").show();
                    // vzdy se drzet na konci posuvniku v okne
                    $('.chatbot_message').scrollTop($('.chatbot_message')[0].scrollHeight);
                }, 3002);

                // samotnu prepis zpravy do okna chatu s malym opozdenim
                setTimeout(function () {
                    $(newChatbotMessage).appendTo('.chatbot_message');
                    $('.chatbot_message').scrollTop($('.chatbot_message')[0].scrollHeight);
                }, 1000);

                // hledani uzivatelskych odpovedi, ktere souvisi se zpravou chatbota
                var associatedUserMessages = data.user_messages.filter(message => message.chatbot_message_id == answerId);

                // vytvareni tlacitek s moznymi zpravami uzivatele
                associatedUserMessages.forEach(function (userMessage) {
                     // specialni pripad - osetreni nekterych moznych odpovedi, ktere se nehodi pro dany nabytek v doporucovani nabytku
                    if (userMessage.chatbot_message_id == 10) {
                        switch (true) {
                            case ((historyArray[historyArray.length - 2] == "Skříně" || historyArray[historyArray.length - 4] == "Skříně") && userMessage.id !== 23 ):
                                break;

                            case ((historyArray[historyArray.length - 2] == "Křesla" || historyArray[historyArray.length - 4] == "Křesla") && userMessage.id !== 24 &&  userMessage.id !== 25):
                                break;

                            case ((historyArray[historyArray.length - 2] == "Židle" || historyArray[historyArray.length - 4] == "Židle") && userMessage.id !== 26 && userMessage.id !== 27):
                                break;

                            case ((historyArray[historyArray.length - 2] == "Stoly" || historyArray[historyArray.length - 4] == "Stoly") && userMessage.id !== 28 && userMessage.id !== 29):
                                break;

                            case ((historyArray[historyArray.length - 2] == "Postele" || historyArray[historyArray.length - 4] == "Postele") && userMessage.id !== 30 && userMessage.id !== 31 && userMessage.id !== 32):
                                break;

                            default:
                                var newButton = $('<button class="user_choice" data-answer-id="' + userMessage.answer_id + '">' + userMessage.message + '</button>');
                        }
                    }
                    else {
                        var newButton = $('<button class="user_choice" data-answer-id="' + userMessage.answer_id + '">' + userMessage.message + '</button>');
                    }

                    // pokud se uzivatel ocitne na zacatku chatu, tak exit tlacitko schovame
                    if (userMessage.chatbot_message_id == 1) {
                        setTimeout(function () {
                            $("#exit").hide();
                            $('.chatbot_message').scrollTop($('.chatbot_message')[0].scrollHeight);
                        }, 3003);
                    }

                    // s dalsim opozdenim se objevi moznosti odpovedi uzivatele
                    setTimeout(function () {
                        $(newButton).appendTo('.chatbot_message');
                    }, 3000);
                });

                // exit tlacitko se objevi na konci moznosti
                setTimeout(function () {
                    $("#exit").appendTo('.chatbot_message');
                    
                }, 3001);
                
            });
        }); 
});